package HT.fx;

import java.io.*;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

import fi.jyu.mit.ohj2.Mjonot;


/**
 * @author joonatan, thmustap
 * @version 7.3.2024
 *
 */
public class Ottelu {
    private int idNro;
    private int pelaajaNro1;
    private int pelaajaNro2;
    private int pelaajaNro3;
    private int pelaajaNro4;
    private int voittajaNro1;
    private int voittajaNro2;
    private static int seuraavaNro = 1;
    private LocalDate paivamaara;
    private String lopputulos;
    
    
    /**
     * Ottelun constructori
     * @param paivamaara pvm 
     * @param pelaajaNro1 pelaaja1
     * @param pelaajaNro2 pelaaja1
     * @param pelaajaNro3 pelaaja1
     * @param pelaajaNro4 pelaaja1
     * @param voittajaNro1 voittaja 1
     * @param voittajaNro2 voittaja 2
     * @param lopputulos tulos
     */
    public Ottelu(LocalDate paivamaara, int pelaajaNro1, int pelaajaNro2, int pelaajaNro3, int pelaajaNro4, int voittajaNro1, int voittajaNro2, String lopputulos ) {
        this.paivamaara=paivamaara;
        this.pelaajaNro1 = pelaajaNro1;
        this.pelaajaNro2 = pelaajaNro2;
        this.pelaajaNro3 = pelaajaNro3;
        this.pelaajaNro4 = pelaajaNro4;
        this.voittajaNro1 = voittajaNro1;
        this.voittajaNro2 = voittajaNro2;
        this.lopputulos = lopputulos;
        
        
    }
    
    /**
     * Ottelun constructori
     * @param idNro ottelun id
     * @param paivamaara pvm 
     * @param pelaajaNro1 pelaaja1
     * @param pelaajaNro2 pelaaja1
     * @param pelaajaNro3 pelaaja1
     * @param pelaajaNro4 pelaaja1
     * @param voittajaNro1 voittaja 1
     * @param voittajaNro2 voittaja 2
     * @param lopputulos tulos
     */
    public Ottelu(int idNro, LocalDate paivamaara, int pelaajaNro1, int pelaajaNro2, int pelaajaNro3, int pelaajaNro4, int voittajaNro1, int voittajaNro2, String lopputulos ) {
        this.idNro = idNro;
        this.paivamaara=paivamaara;
        this.pelaajaNro1 = pelaajaNro1;
        this.pelaajaNro2 = pelaajaNro2;
        this.pelaajaNro3 = pelaajaNro3;
        this.pelaajaNro4 = pelaajaNro4;
        this.voittajaNro1 = voittajaNro1;
        this.voittajaNro2 = voittajaNro2;
        this.lopputulos = lopputulos;
        
        
    }
    
    /**
     * @return palauttaa pelaajan tiedot toString-muodossa
     */
    public String getTiedot() {
        return idNro + "|" + pelaajaNro1 + "|" +pelaajaNro2 + "|" +pelaajaNro3 + "|" +pelaajaNro4 +"|" +voittajaNro1 + "|" + voittajaNro2+"|"+paivamaara+"|"+ lopputulos;
    }
    
    /**
     * Tyhjä contructori ottelulle
     */
    public Ottelu() {
        //Ei vielä mitään.
    }
    
    /**
     * Tulostetaan ottelun tiedot
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        System.out.println("joo");
    }
    
    /**
     * Tulostetaan pelaajan tiedot
     * @param os tietovirta johon tulostetaan
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }
    
    /**
     * Antaa ottelulle seuraavan tunnusnumeron
     * @return uusi tunnusnumero
     * @example
     * <pre name="test">
     * Ottelu ottelu1 = new Ottelu();
     * Ottelu ottelu2 = new Ottelu();
     * ottelu1.rekisteroi();
     * ottelu2.rekisteroi();
     * int n1 = ottelu1.getIdNro();
     * int n2 = ottelu2.getIdNro();
     * n1 === n2-n1;
     * </pre>
     */
    public int rekisteroi() {
        idNro = seuraavaNro;
        seuraavaNro++;
        return idNro;
    }
    
    /**
     * Palautetaan ottelun id
     * @return ottelun id
     */
    public int getIdNro() {
        return idNro;
    }
    
    
    
    /**
     * Palauttaa tietyn ottelun pelaajanumerot
     * @return ottelun pelaajien numerot
     */
    public int[] getPelaajaNrot() {
        int[] numerot = new int[] {pelaajaNro1,pelaajaNro2,pelaajaNro3,pelaajaNro4};
        return numerot;
    }
    
    /**
     * Erottelee ottelutiedot tekstitiedostosta
     * @param sb eroteltava teksti
     */
    public void parse(StringBuffer sb) {
        seuraavaNro++;
        idNro = Integer.parseInt(Mjonot.erota(sb,'|',false));
        pelaajaNro1 = Integer.parseInt(Mjonot.erota(sb,'|',false));
        pelaajaNro2 = Integer.parseInt(Mjonot.erota(sb,'|',false));
        pelaajaNro3 = Integer.parseInt(Mjonot.erota(sb,'|',false));
        pelaajaNro4 = Integer.parseInt(Mjonot.erota(sb,'|',false));
        voittajaNro1 = Integer.parseInt(Mjonot.erota(sb,'|',false));
        voittajaNro2 = Integer.parseInt(Mjonot.erota(sb,'|',false));
        String paivamaara1 = Mjonot.erota(sb,'|',false);
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-M-d");
        LocalDate pvm = LocalDate.parse(paivamaara1, formatter);
        paivamaara=pvm;
        lopputulos = Mjonot.erota(sb,'|',false);

    }
    
    /**
     * Palautetaan ensimmäisen voittajan numero
     * @return pelaajan id
     */
    public int getVoittajaNro1() {
        return voittajaNro1;
    }
    
    /**
     * Palautetaan toisen voittajan numero
     * @return pelaajan id
     */
    public int getVoittajaNro2() {
        return voittajaNro2;
    }
    
    /**
     * @return ottelun lopputulos
     */
    public String getLopputulos(){
        return lopputulos;
    }
    
    /**
     * @return ottelun päivämäärä
     */
    public LocalDate getDate() {
        return paivamaara;
    }
    
    
    /**
     * @return palauttaa tunnusnumeron
     */
    public int getTunnusNro() {
       
        return idNro;
    }

    /**
     * @param pelaajaNro asettaa ensimmäisen pelaajanumeron
     */
    public void setpelaajaNro1(int pelaajaNro) {
        pelaajaNro1 = pelaajaNro;
        
    }

    /**
     * @param pelaajaNro asettaa toisen pelaajanumeron
     */
    public void setpelaajaNro2(int pelaajaNro) {
        pelaajaNro2 = pelaajaNro;
        
    }

    /**
     * @param pelaajaNro asettaa kolmannen pelaajanumeron
     */
    public void setpelaajaNro3(int pelaajaNro) {
        pelaajaNro3 = pelaajaNro;
        
    }

    /**
     * @param pelaajaNro asettaa neljännen pelaajanumeron
     */
    public void setpelaajaNro4(int pelaajaNro) {
        pelaajaNro4 = pelaajaNro;
        
    }

    /**
     * @param voittajaNro asettaa ensimmäisen voittajan numeron
     */
    public void setvoittajaNro1(int voittajaNro) {
        voittajaNro1 = voittajaNro;
        
    }

    /**
     * @param voittajaNro asettaa toisen voittajan numeron
     */
    public void setvoittajaNro2(int voittajaNro) {
        voittajaNro2 = voittajaNro;
        
    }

    /**
     * @param value asettaa päivämäärän
     */
    public void setPvm(LocalDate value) {
        paivamaara = value;
        
    }

    /**
     * @param lopputulos2 asettaa lopputuloksen
     */
    public void setLopputulos(String lopputulos2) {
        lopputulos = lopputulos2;
        
    }
    
    /**
     * @param i asettaa tunnusnumeron
     */
    public void setTunnusNro(int i) {
        idNro = i;

    }
    
}