package HT.fx;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.Scanner;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import fi.jyu.mit.ohj2.Mjonot;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 * @author joonatan, tuomas
 * @version 13.3.2024
 *
 */
public class OtteluIkkunaGUIController implements ModalControllerInterface<String> {
    
    @FXML private VBox Joukkue1VBox;

    @FXML private VBox Joukkue2VBox;

    @FXML private VBox MuokkaaVBox;

    @FXML private VBox TulosVBox;

    @FXML private void lisaatekstikentta(VBox boksi) {
        TextField newField = new TextField();
        boksi.getChildren().add(newField);
    }
    
    @FXML private void lisaaNappi(VBox boksi) {
        Button uusiNappi = new Button("Muokkaa");
        uusiNappi.setOnMouseClicked(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent arg0) {
                int i = boksi.getChildren().indexOf(uusiNappi);
                muokkaaOttelu(null, "kanat", i);
            }
        });
        boksi.getChildren().add(uusiNappi);
    }
    
    @FXML  void handleLisaaOttelu() {
        
        LisaaOttelu(null, "kanat");
        
            lisaakentat();
            SyotaTulos();
        
        
    }
    
    @FXML void handleHaeTiedot(MouseEvent event) {
        //PadelMainGUIController.getKarkelo().lueTiedostosta("Ottelutiedot", 2);
        
        if(tulossyotetty<0) {
            int i = 0;
            while ( i<PadelMainGUIController.getKarkelo().noudaOttelut().size()) {
                
                lisaakentat();
                i++;
                
            }
            tulossyotetty++;
        }
        SyotaTulos();
        //Lukija("Ottelutiedot");
    }

    @FXML void handleTallenna(MouseEvent event) throws SailoException {
        tallenna();
    }
    //=====================================
    
    /**
     * @param modalityStage -
     * @param oletus - 
     * @return avaa ottelun lisäysikkunan
     */
    public static String LisaaOttelu(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                PadelLisaaOtteluGUIController.class.getResource("PadelLisaaOtteluGUIView.fxml"),
                "Lisää ottelu", modalityStage, oletus);
    }
    
    /**
     * @param modalityStage -
     * @param oletus - 
     * @param i määrittelee ketä muokataan
     * @return avaa muokkausikkunan
     */
    public static String muokkaaOttelu(Stage modalityStage, String oletus, int i) {
        muokattava = i-1;
        return ModalController.showModal(
                PadelLisaaOtteluGUIController.class.getResource("PadelLisaaOtteluGUIView.fxml"),
                "Lisää ottelu", modalityStage, oletus);
    }
    
    /**
     * Tallentaa ottelut
     * @throws SailoException -
     */
    public void tallenna() throws SailoException {
        PadelMainGUIController.getKarkelo().talleta();
    }

    /**
     * Lisää kentät ikkunaan
     */
    public void lisaakentat() {
        lisaatekstikentta(Joukkue1VBox);
        lisaatekstikentta(Joukkue2VBox);
        lisaaNappi(MuokkaaVBox);
        lisaatekstikentta(TulosVBox);
    }
    
    /**
     * Muuttuja, jolla ohjelma tarkistaa muokataanko ja kertoo mitä muokataan.
     */
    public static int muokattava = -1;
    /**
     * Muuttuja, joka varmistaa, ettei tuloksia syötetä liikaa.
     */
    public static int tulossyotetty=-1;
    
    
    /**
     * Hakee kaikki luodun karkelon ottelut ja syöttää niiden tiedot
     * 
     * Tämän takia ei syötä tietoja oikein 
     */
    public void SyotaTulos() {
        int i = 0;
        int m = 0;
        int n = 0;

        
        for (Node lapsi : Joukkue1VBox.getChildren()) {
            Ottelu ottelu = PadelMainGUIController.getKarkelo().noudaOttelu(i);
            int[] numerot = ottelu.getPelaajaNrot();
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(haePelaaja(numerot[0]) + ", " + haePelaaja(numerot[1]));
                i++;
            }
        }
        
        for (Node lapsi : TulosVBox.getChildren()) {
            Ottelu ottelu = PadelMainGUIController.getKarkelo().noudaOttelu(m);
            
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(ottelu.getLopputulos());
                m++;
            }
            
        }
        
        for (Node lapsi : Joukkue2VBox.getChildren()) {
            Ottelu ottelu = PadelMainGUIController.getKarkelo().noudaOttelu(n);
            int[] numerot = ottelu.getPelaajaNrot();
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(haePelaaja(numerot[2]) + ", " + haePelaaja(numerot[3]));
                n++;
            }
            
        }

    }
    
    /**
     * @param i haettavan pelaajan tunnusnumero
     * @return palauttaa i:nnen pelaajan nimen
     */
    public String haePelaaja(int i) {
        return PadelMainGUIController.getKarkelo().annaPelaaja(i).getNimi();
    }
    

    @Override
    public String getResult() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void handleShown() {
        // TODO Auto-generated method stub
        
    }

    @Override
    public void setDefault(String arg0) {
        // TODO Auto-generated method stub
        
    }

}
