package HT.fx;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.Arrays;
import java.util.Scanner;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.ohj2.Mjonot;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import HT.fx.Pelaaja;
import HT.fx.Pelaajat;
import HT.fx.Karkelot;
import HT.fx.SailoException;


/**
 * @author joonatan tuomas
 * @version 31.1.2024
 *
 */
public class PadelMainGUIController {
    

    @FXML private VBox AutoVbox;

    @FXML private VBox IkaVbox;

    @FXML private VBox NimiVbox;

    @FXML private VBox RatingVbox;

    @FXML private VBox SapoVbox;
    
    @FXML private VBox MuokkaaVbox;
    
    @FXML private void lisaaNappi(VBox boksi) {
        Button uusiNappi = new Button("Muokkaa");
        uusiNappi.setOnMouseClicked(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent arg0) {
                int m = boksi.getChildren().indexOf(uusiNappi);
                muokkaaPelaaja(null, "kanat", m);
                
                poistaKaikkiKentat();
                
                
                int i = 0;
                while ( i<karkelo.getPelaajia()) {
                    
                    lisaakentat();
                    i++;
                    
                }
                syotatiedot();
            }
        });
        boksi.getChildren().add(uusiNappi);
    }
    
    
    @FXML void handleLisaamuokkaaottelu() {
         handleLisaaOttelu(null, "kanat");
         
         
    }

    
    @FXML void handleLisaapelaaja() {
        handleLisaaPelaaja(null, "kanat");
        lisaakentat();
        syotatiedot();
        
    }
    

    @FXML void handleTallenna() throws SailoException {
        karkelo.talleta();
    }
    
    
    @FXML void handleHaeTiedot() {  
        syotatiedot();
    }
    
    
    @FXML private void lisaatekstikentta(VBox boksi) {
        TextField newField = new TextField();
        boksi.getChildren().add(newField);
    }
    

    //=======================
     
    /**
     * karkelon oma karkelo johon tallennetaan pelaajat ja ottelut.
     */
    private static Karkelot karkelo;
    
    /**
     * @param modalityStage -
     * @param oletus -
     * @return controller
     */
    public static String handleLisaaPelaaja(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                LisaaPelaajaGUIController.class.getResource("LisaaPelaajaGUIView.fxml"),
                "Lisää pelaaja", modalityStage, oletus);
    }
    
    
    /**
     * @param modalityStage -
     * @param oletus -
     * @param m luku
     * @return controller
     */
    public static String muokkaaPelaaja(Stage modalityStage, String oletus, int m) {
        muokattava = m;
        return ModalController.showModal(
                LisaaPelaajaGUIController.class.getResource("LisaaPelaajaGUIView.fxml"),
                "Lisää pelaaja", modalityStage, oletus);
    }
    
    
    
    /**
     * @param modalityStage -
     * @param oletus -
     * @return controller
     */
    public static String handleLisaaOttelu(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                OtteluIkkunaGUIController.class.getResource("OtteluIkkunaGUIView.fxml"),
                "Lisää pelaaja", modalityStage, oletus);
    }
    
    
    /**
     * Poistaa kentät yhdeltä VBoxilta
     * @param boksi josta poistetaan
     */
    public void poistaKentatYhdesta(VBox boksi) {
        boksi.getChildren().removeIf(node -> node instanceof TextField);
        boksi.getChildren().removeIf(node -> node instanceof Button);
    }
    
    
   /**
    * Poistaa kaikki kentät sarakkeelta.
    */
public void poistaKaikkiKentat() {
       poistaKentatYhdesta(NimiVbox);
       poistaKentatYhdesta(IkaVbox);
       poistaKentatYhdesta(RatingVbox);
       poistaKentatYhdesta(SapoVbox);
       poistaKentatYhdesta(AutoVbox);
       poistaKentatYhdesta(MuokkaaVbox);
       
   }
    

    /**
     * Lisää tarvittavat kentät kun pelaaja luodaan
     */
    public void lisaakentat() {
        lisaatekstikentta(NimiVbox);
        lisaatekstikentta(IkaVbox);
        lisaatekstikentta(RatingVbox);
        lisaatekstikentta(SapoVbox);
        lisaatekstikentta(AutoVbox);
        lisaaNappi(MuokkaaVbox);
    }
    
    
    /**
     * Muuttuja, jolla ohjelma tarkistaa muokataanko ja kertoo ketä muokataan.
     */
    public static int muokattava = -1;
    
    /**
     * Syöttää tiedot tekstikenttiin
     */ 
    public void syotatiedot() {
        
        int i = 0;
        int j = 0;
        int k = 0;
        int m = 0;
        int n = 0;
    
        Pelaaja pelaajat2[] = getKarkelo().getPelaajat();
        Pelaaja pelaajat[] = jarjestaTaulu(pelaajat2);
        

        for (Node lapsi : NimiVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
                tf.setText(pelaajat[i].getNimi());
                i++;
            }
        }
        
        for (Node lapsi : IkaVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
                tf.setText(String.valueOf(pelaajat[j].getIka()));
                j++;
            }
        }
        
        for (Node lapsi : RatingVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                tf.setText(String.valueOf(pelaajat[n].getRating()));
                n++;
            }
        }
        
        for (Node lapsi : SapoVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
            
                 tf.setText(pelaajat[k].getSahkoposti());
                 k++;
            }
        }
        
        for (Node lapsi : AutoVbox.getChildren()) {
            if (lapsi instanceof TextField) {
                TextField tf = (TextField) lapsi;
                 
                if(pelaajat[m].getAuto()) {
                    tf.setText("Kyllä");
                        
                }else {tf.setText("Ei");}
                
                m++;
            }
        }
        
    }
    
    
    /**
     * järjestää pelaaja taulukon pelaajien ratingin mukaan
     * @param pelaajat taulukko jota järjestettä
     * @return annettu taulukko järjestettynä
     */
    public Pelaaja[] jarjestaTaulu(Pelaaja pelaajat[]) {
        
        int i = 0; 
        while (i<getKarkelo().getPelaajia()-1) {
            if(pelaajat[i+1].getRating() > pelaajat[i].getRating()) {
                Pelaaja vara = pelaajat[i];
                pelaajat[i] = pelaajat[i+1];
                pelaajat[i+1] = vara;
                i = -1;
            }
            i++;
        }
        return pelaajat;
    }


    /**
     * @param karkelo karkelo jota käytetään tässä käyttöliittymässä
     */
    public void setKarkelo(Karkelot karkelo) {
        PadelMainGUIController.karkelo = karkelo;
    }


    /**
     * rekisteröi ja lisää parametrina annetun uuden pelaajan
     * @param uusi pelaaja
     */
    public static void LisaaPelaaja(Pelaaja uusi) {
        

        uusi.rekisteroi();
        try {
            karkelo.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden luomisessa " + e.getMessage());
            return;
        }
    }
    
    
    /**
     * rekisteröi ja lisää parametrina annetun uuden ottelun
     * @param uusi ottelu
     */
    public static void LisaaOttelu(Ottelu uusi) {
        
        uusi.rekisteroi();
        karkelo.lisaa(uusi);
    }


    /**
     * Palauttaa controllerin käyttämän karkelon jotta sitä voi käyttää muissa controllereissa
     * @return karkelo
     */
    public static Karkelot getKarkelo() {
        return karkelo;
    }

}