package HT.fx;

import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.fxml.FXMLLoader;


/**
 * @author joonatan, tuomas
 * @version 31.1.2024
 *
 */
public class PadelMainMain extends Application {
    @Override
    public void start(Stage primaryStage) {
        try {
            FXMLLoader ldr = new FXMLLoader(getClass().getResource("PadelMainGUIView.fxml"));
            final Pane root = ldr.load();
            final PadelMainGUIController padelmainCtrl = (PadelMainGUIController) ldr.getController();
            Scene scene = new Scene(root);
            scene.getStylesheets().add(getClass().getResource("padelmain.css").toExternalForm());
            primaryStage.setScene(scene);
            primaryStage.setTitle("PadelMain");
            primaryStage.show();
            
            Karkelot karkelo = new Karkelot();  
            padelmainCtrl.setKarkelo(karkelo);
            
            //testataan jos avautuisi pelaajat suoraan
            karkelo.lueTiedostosta("Pelaajatiedot", 1);
            karkelo.lueTiedostosta("Ottelutiedot", 2);

            int i = 0;
            while ( i<karkelo.getPelaajia()) {
                
                padelmainCtrl.lisaakentat();
                i++;
                
            }
            padelmainCtrl.syotatiedot();

        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    
    /**
     * @param args Ei kaytossa
     */
    public static void main(String[] args) {
        launch(args);
    }
}